package  
{
	import flash.geom.ColorTransform;
	import flash.sampler.NewObjectSample;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author tony
	 */
	public class Player extends Bit 
	{
		public var move_timer : Number = 0;
		public var shoot_timer : Number = 0;
		public var heal_timer : Number = 0;
		
		public var move_wait: Number = .2;
		public var shoot_wait: Number = .2;
		public var heal_wait: Number = .2;
		
		public var health : Number = 100;
		public var score: Number = 0;
		
		public var score_txt : Text = new Text("asdf", 400, -1);
		public var high_score_txt : Text = new Text("asdf", 300, -1);
		
		public function Player(index:Number) 
		{
			super(index);
			
			score_txt.relative = false;
			addGraphic(score_txt);
			high_score_txt.relative = false;
			addGraphic(high_score_txt);
			
			target_color = 0x66ca64;
			
			type = "player";
		}
		
		override public function update():void 
		{
			super.update();
			
			if (Input.check(Key.A))
			{
				if (move_timer > 0) move_timer = 0;
				move_timer -= FP.elapsed;
				if (move_timer < -move_wait && index > 0)
				{
					index--;
					x -= MOVE_SIZE;
					move_timer = 0;
					image.color = 0x06ff00;
				}
			}
			if (Input.check(Key.D))
			{
				if (move_timer < 0) move_timer = 0;
				move_timer += FP.elapsed;
				if (move_timer > move_wait && index < GRID_SIZE - 1)
				{
					index++;
					x += MOVE_SIZE;
					move_timer = 0;
					image.color = 0x06ff00;
				}
			}
			
			
			var bullet: Player_Bullet;
			if (Input.check(Key.LEFT) && index > 0)
			{
				shoot_timer += FP.elapsed;
				if (shoot_timer > shoot_wait)
				{
					shoot_timer = 0;
					new Sfx(Assets.snd_player_shoot).play();
					
					bullet = new Player_Bullet(-1, index - 1);
					world.add(bullet);
				}
			}
			
			if (!Input.check(Key.LEFT) && Input.check(Key.RIGHT) && index < GRID_SIZE - 1)
			{
				shoot_timer += FP.elapsed;
				if (shoot_timer > shoot_wait)
				{
					shoot_timer = 0;
					
					new Sfx(Assets.snd_player_shoot).play();
					
					bullet = new Player_Bullet(1, index + 1);
					world.add(bullet);
				}
			}
			
			
			var slider:Slider = collide("slider", x, y) as Slider;
			if (slider)
			{
				world.remove(slider);
				health -= slider.damage;
				new Sfx(Assets.snd_shoot).play();
				if (health < 0)
				{
					new Sfx(Assets.snd_player_die).play();
					
					
					var nw: mah_world = world as mah_world;
					FP.world = new world_menu(nw.high_score);
					//health = 100;
					//index = 13;
					//x = 3 + (MOVE_SIZE * index) + 3;
					
					//score = 0;
					//
					//var s_list:Array = [];
					//world.getClass(Slider, s_list);
					//for each (var gpi:Slider in s_list)
						//world.remove(gpi);
				}
			}
			
			
			if (index == 15 || index == 16)
			{
				heal_timer += FP.elapsed;
				if (heal_timer > heal_wait)
				{
					heal_timer = 0;
					if (health < 100)
					{
						health++;
						new Sfx(Assets.snd_healing).play();
						var w: mah_world = world as mah_world;
						(w.tiles[index] as Tile).image.color = 0x06ff00;
					}
					
				}
			}
			
			
			var p : Prize = collide("prize", x, y) as Prize;
			if (p)
			{
				world.remove(p);
				score++;
				var pw: mah_world = world as mah_world;
				if (pw.high_score < score) pw.high_score = score;
				(pw.tiles[index] as Tile).image.color = 0xff9908;
				
				new Sfx(Assets.snd_get_prize).play();
				
				world.add(new Prize(FP.choose(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14, 17,
											  18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30)));
			}
			
			var dhs: mah_world = world as mah_world;
			high_score_txt.text = "Best: " + dhs.high_score.toString();
			score_txt.text = "Score: " + score.toString();
		}
		
		override public function render():void 
		{
			super.render();
			
			Draw.rect(3, 3, health * 2, 7, FP.getColorRGB(FP.rand(255), FP.rand(255), 75));
			Draw.rect(3, 3, 2, 7, FP.getColorRGB(FP.rand(255), 50, 75));
			Draw.rect(100 * 2 + 3, 3, 2, 7, FP.getColorRGB(FP.rand(255), FP.rand(255), 75));
		}
	}

}